﻿/* <<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<<
	
	Particle3DTest Document Class
	
    date: 20080717 + 22:30

    WCAN mini ActionScript Vol.7 サンプル

>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>>> */



package {

    import flash.display.MovieClip;
	import flash.events.Event;
	import flash.events.MouseEvent;
    import flash.text.TextField;
    import flash.text.TextFormat;
	import flash.filters.BlurFilter;
	import flash.geom.ColorTransform;
	import flash.geom.Rectangle;
	import flash.geom.Point;
	import flash.utils.getTimer;

    import com.dangries.loaders.*;
    import com.dangries.bitmapUtilities.PictureAtomizer;
    import com.dangries.objects.Particle3D;
    import com.dangries.geom3D.*;
    import com.dangries.display.*;

    
    public class Particle3DTest extends MovieClip {
        
        private var imagePath: Array;               // 画像パス
        private var images: Array;                  // 読込画像
        private var particles: Array;               // つぶつぶ
        private var p: Particle3D;                  // つぶ
        private var board: RotatingParticleBoard;   // ボード
        private var picLoader: PictureLoader;       // ローダー
        private var atomizer: PictureAtomizer;      // 解析・変換
        
        private var param: Number;                  // ちょう強引な物理 1
        private var ctime: Number = 0;              // ちょう強引な物理 1
        private var addSpeed: Number;               // ちょう強引な物理 1

        // 効果
        private var blur: BlurFilter;
        private var darken: ColorTransform;
        private var boardRect: Rectangle;
        private var filterPoint: Point;

        


        /**
         * Constructor
         */
        public function Particle3DTest () {
            
            _onInit();
        }



        /**
         * Init
         */
        private function _onInit (): void {

            imagePath = ["bigchu.png"];

            picLoader = new PictureLoader();
            
            // ボードの設定
            board = new RotatingParticleBoard(
                stage.stageWidth,
                stage.stageHeight - 80,
                true,
                0x00000000,
                300);

            board.setDepthDarken(-10, -80, 1);
            board.makeFrame(1, 0x444444, 0);
            board.holder.x = stage.stageWidth / 2 - board.width / 2;
            board.holder.y = stage.stageHeight / 2 - board.height / 2 - 40;

            // ボードを回転させる
            board.autoQuaternion = new Quaternion(
                Math.cos(Math.PI / 800),
                0,
                Math.sin(Math.PI / 800),
                0);

            // 効果
            blur = new BlurFilter(10, 10);
            darken = new ColorTransform(1, 1, 1, 0.9);
            boardRect = new Rectangle(0, 0, board.width, board.height);
            filterPoint = new Point(0, 0);
            
            picLoader.addEventListener(PictureLoader.ALL_PICS_LOADED, _onSetup);
            picLoader.loadPics(imagePath);
        }


        private function _onSetup (e: Event): void {
            
            // 読み込んだ画像
            images = picLoader.picArray;
            picLoader.removeEventListener(PictureLoader.ALL_PICS_LOADED, _onSetup);

            // にゅぅ
            atomizer = new PictureAtomizer();

            // 粗さ
            atomizer.sampling = 2;

            // 間隔
            atomizer.spread = 1;

            // 散布
            atomizer.sampleFuzzX = 0;
            atomizer.sampleFuzzY = 0;
            
            // 原点
            atomizer.originX = Math.floor(images[0].width / 2);
            atomizer.originY = Math.floor(images[0].height / 2 + 30);
            
            
            // びんびんするかばんばんするか？
            //atomizer.addEventListener(PictureAtomizer.PARTICLES_CREATED, _onSetupBinbin);
            atomizer.addEventListener(PictureAtomizer.PARTICLES_CREATED, _onSetupBanban);
            stage.addEventListener(MouseEvent.MOUSE_DOWN, _onSetupBanban);

            // 解析開始
            atomizer.createParticles(images[0]);
        }




        /**
         * 粒子がびんびんするぜ！
         */
        private function _onSetupBinbin (e: Event): void {

            particles = atomizer.particleArray;
            atomizer.setPositionsByPic(0, 0, 0);
            stage.addChild(board.holder);
            stage.addEventListener(Event.ENTER_FRAME, _onDrawBinbin);
            param = 0;
            _createInfotext();
        }

        private function _onDrawBinbin (e: Event): void {
            
            var i: uint;
            var pl: uint =  particles.length - 1;
            
            // びんびん処理
            param = 0.65 * Math.min(
                1.75, Math.max(0, (1 - Math.cos(getTimer() * .0003) -0.25 * Math.cos(getTimer() * .0006))));

            for (i = 0; i <= pl; i++) {
                p = particles[i];
                p.z = param*(p.lum - 128);
            }
            
            //board.bitmapData.applyFilter(board.bitmapData, boardRect, filterPoint, blur);
            board.bitmapData.colorTransform(boardRect, darken);
            board.drawParticles(particles);
        }




        /**
         * 粒子がばんばんするぜ！
         */
        private function _onSetupBanban (e: Event): void {

            particles = atomizer.particleArray;
            atomizer.setPositionsByPic(0,0,0);
            stage.addChild(board.holder);
            stage.addEventListener(Event.ENTER_FRAME, _onDrawBanban);

            var i: uint;
            var pl: uint =  particles.length - 1;
            for (i = 0; i <= pl; i++) {

                p = particles[i];
                p.x = 0;
                p.y = 0;
                p.z = 0;
            }

            addSpeed = 4;
            param = 0;
            ctime = 0;

            _createInfotext();
        }

        private function _onDrawBanban (e: Event): void {
            
            var i: uint;
            var pl: uint =  particles.length - 1;

            if (addSpeed < 0.1) {
                
                param *= 0.98;

            } else {
                addSpeed *= 0.9;
                param =+ addSpeed;
            }

            ctime += 0.01;

            for (i = 0; i <= pl; i++) {

                p = particles[i];
                p.z += param * (p.lum * 0.05 - 10);
                p.x += param * (p.picX * 0.06);
                p.y += param * (p.picY * 0.06);
                p.y += ctime;
            }

            board.bitmapData.applyFilter(board.bitmapData, boardRect, filterPoint, blur);
            board.bitmapData.colorTransform(boardRect, darken);
            board.drawParticles(particles);
            
        }


        
        /**
         * つぶつぶの数知りたいので
         */
        private function _createInfotext (): void {

            var box: TextField = new TextField();
            var format: TextFormat = new TextFormat("arial", 12, 0xCCCCCC);

            box.defaultTextFormat = format;
            box.text = String(particles.length) + " つぶつぶ";
            box.x = board.holder.x + board.width / 2 - box.width / 2;
            box.y = board.holder.y + board.height - 20;

            stage.addChild(box);
        }

    }
}
